package itexpert.chap10;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Collection;

import itexpert.common.DsConn;


/**
 * ü Խù   ϴ ׼Ǻ
 * @author kenu
 */
public class ListHandler {
    final static String QUERY_COUNT =
        "SELECT COUNT(*) FROM GUESTBOOK";
    final static String QUERY_LIST =
        "SELECT * FROM (SELECT /*+ INDEX_DESC(GUESTBOOK PK_GUESTBOOK) */ ROWNUM RSEQ, SEQ, NAME, EMAIL, HOMEPAGE, SUBJECT, CONTENT, LOGTIME FROM GUESTBOOK WHERE ROWNUM <= ?) A WHERE A.RSEQ > ?";
    private int pageSize = 5; //  Խù , ⺻ 5
    private int cpage = 1;
    private int total;

    /**
     *  شϴ Խù  List  ؼ ȯѴ.
     * @return Collection
     * @throws SQLException
     */
    public Collection getList() throws SQLException {
        Connection conn = null;
        PreparedStatement pstmt = null;
        ResultSet rs = null;

        ArrayList list = new ArrayList();
        try {
            conn = DsConn.getConnection();
            // Խù īƮ
            pstmt = conn.prepareStatement(QUERY_COUNT);
            rs = pstmt.executeQuery();
            if(rs.next()) {
                this.total = rs.getInt(1);
            }
            rs.close();
            pstmt.close();

            //   Խù ȣ
            int endNo = pageSize * cpage;
            //  Խù ҷ
            pstmt = conn.prepareStatement(QUERY_LIST);
            pstmt.setInt(1, endNo);
            pstmt.setInt(2, endNo - pageSize);
            rs = pstmt.executeQuery();

            while(rs.next()) {
                // Խù ϳ   ؼ  ȿ  ä
                ArticleBean ab = new ArticleBean();
                ab.setSeq(rs.getInt("seq"));
                ab.setName(    rs.getString("name"));
                ab.setEmail(   rs.getString("email"));
                ab.setHomepage(rs.getString("homepage"));
                ab.setSubject( rs.getString("subject"));
                ab.setContent( rs.getString("content"));
                ab.setLogtime(rs.getTimestamp("logtime"));

                //  ä Խù ϳ Ͽ ߰
                list.add(ab);
            }

        // db  ݱ
        } catch (SQLException e) {
            throw e;
        } finally {
            conn.close();
        }
        return list;
    }
    /**
     * ü Խù  ȯ
     * @return int
     */
    public int getTotal() {
        return total;
    }

    /**
     *   , ۹ȣ 1
     * @param cpage The cpage to set
     */
    public void setCpage(int cpage) {
        if(cpage < 1) cpage = 1;
        this.cpage = cpage;
    }

    /**
     *  Խù  
     * @param pageSize The pageSize to set
     */
    public void setPageSize(int pageSize) {
        this.pageSize = pageSize;
    }

    /**
     *  ȣ ȯ
     * @return int
     */
    public int getCpage() {
        return cpage;
    }

    /**
     *  Խù  ȯ
     * @return int
     */
    public int getPageSize() {
        return pageSize;
    }

}
