package itexpert.chap10.bbs;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import itexpert.common.ClobUtil;
import itexpert.common.CommonUtil;
import itexpert.common.DsConn;

/**
 * BbsArticleBean  ϰ, ⿡ ɿ  Խù  ä
 * ȯѴ.
 * @author kenu
 */
public class BbsViewHandler extends BbsArticleBean {
    final static String QUERY_ONE =
        "SELECT SEQ, REF, STEP, LEV, HIT, NAME, EMAIL, HOMEPAGE, SUBJECT, LOGTIME, CONTENT, HTML, HIT, PSEQ, REPLY, PASSWORD FROM BOARD WHERE  SEQ = :SEQ";
    final static String QUERY_HIT =
        "UPDATE BOARD SET HIT = HIT + 1 WHERE SEQ = :SEQ";

    private String act;
    private String passwd;

    /**
     * Խù ϳ ͼ ɿ  Խù Ѵ.
     * @return BbsArticleBean
     * @throws SQLException
     */
    public BbsArticleBean getOne() throws SQLException {
        getArticle();

        if ("BVIEW".equals(act)) {
            // 뺸  ȸ Ѵ.
            setCountHit();
            // html   뺸 ٹٲ޹ڸ "<br>"  ġó
            this.setContent(
                CommonUtil.showTag(this.getContent(), this.getHtml()));


        } else if ("BREPLY".equals(act)) {
            // 亯ޱ⿡ ۼ  .
            this.setName    (null);
            this.setEmail   (null);
            this.setHomepage(null);
            this.setPassword(null);
            // html   뺸 ٹٲ޹ڸ "<br>"  ġó
            this.setContent(
                CommonUtil.showTag(this.getContent(), this.getHtml()));
            this.setHtml(0);


        } else if ("BMODIFY".equals(act)) {
            //  йȣ Ʋ Խù ȯ ʰ,
            // null  ȯѴ.
            if(!this.getPassword().equals(this.passwd)) {
                return null;
            }
        }

        return this;
    }

    /**
     * seq شϴ Խù  ä.
     * @throws SQLException
     */
    public void getArticle() throws SQLException {
        Connection conn = null;
        PreparedStatement pstmt = null;
        ResultSet rs = null;

        try {

            conn = DsConn.getConnection();

            pstmt = conn.prepareStatement(QUERY_ONE);
            pstmt.setInt(1, this.getSeq());
            rs = pstmt.executeQuery();

            if (rs.next()) {
                this.setSeq(rs.getInt("seq"));
                this.setRef(rs.getInt("ref"));
                this.setStep(rs.getInt("step"));
                this.setLev(rs.getInt("lev"));
                this.setName(rs.getString("name"));
                this.setEmail(rs.getString("email"));
                this.setHomepage(rs.getString("homepage"));
                this.setSubject(rs.getString("subject"));
                this.setLogtime(rs.getTimestamp("logtime"));
                this.setHtml(rs.getInt("html"));
                this.setHit(rs.getInt("hit"));
                this.setPseq(rs.getInt("pseq"));
                this.setReply(rs.getInt("reply"));
                this.setPassword(rs.getString("password"));

                this.setContent(new ClobUtil().getClob(rs, "CONTENT"));

            }

            // db  ݱ
        } catch (SQLException e) {
            throw e;
        } finally {
            conn.close();
        }
    }

    /**
     * ȸ Ѵ.
     * @throws SQLException
     */
    public void setCountHit() throws SQLException {
        Connection conn = null;
        PreparedStatement pstmt = null;
        ResultSet rs = null;

        try {

            conn = DsConn.getConnection();

            // Խù ȸ īƮ
            pstmt = conn.prepareStatement(QUERY_HIT);
            pstmt.setInt(1, this.getSeq());
            pstmt.executeUpdate();
            pstmt.close();

            //   ȸϴ Խù ݿѴ.
            this.setHit(this.getHit() + 1);

            // db  ݱ
        } catch (SQLException e) {
            throw e;
        } finally {
            conn.close();
        }

    }

    /**
     * Խù 뵵 Ѵ.
     * @param act The act to set
     */
    public void setAct(String act) {
        this.act = act;
    }

    /**
     * Sets the passwd.
     * @param passwd The passwd to set
     */
    public void setPasswd(String passwd) {
        this.passwd = passwd;
    }

}
