package itexpert.chap10.bbs;

import java.io.IOException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import itexpert.common.*;

/**
 * Է   Է, , 亯 ɿ ° ؼ DB Ѵ.
 * @author kenu
 *
 */
public class BbsWriteHandler extends BbsArticleBean {

    //  seq ȣ
    final static String QUERY_SEQ =
        "SELECT SEQ_BOARD.NEXTVAL SEQ FROM DUAL";
    // ִ ref ȣ
    final static String QUERY_REF =
        "SELECT /*+ INDEX_DESC(BOARD IDX_BOARD_REF)*/ REF FROM BOARD";
    // Է, 亯 
    final static String QUERY_INSERT =
        "INSERT INTO BOARD (SEQ, REF, STEP, LEV, NAME, EMAIL, HOMEPAGE, SUBJECT, CONTENT, PASSWORD, HTML, LOGTIME, HIT, PSEQ, REPLY) VALUES ( :SEQ, :REF, :STEP,:LEV, :NAME, :EMAIL, :HOMEPAGE, :SUBJECT, EMPTY_CLOB(), :PASSWORD, :HTML, SYSDATE, :HIT, :PSEQ, :REPLY)";
    //  
    final static String QUERY_MODIFY =
        "UPDATE BOARD SET NAME = :NAME, EMAIL = :EMAIL, HOMEPAGE = :HOMEPAGE, SUBJECT = :SUBJECT, CONTENT = EMPTY_CLOB(), PASSWORD = :PASSWORD, HTML = :HTML WHERE SEQ = :SEQ";
    // 亯ޱ  step  
    final static String QUERY_UPDATE_STEP =
        "UPDATE BOARD SET STEP = STEP + 1 WHERE REF = :REF AND STEP > :STEP";
    // 亯ޱ  θۿ 亯  ϳ 
    final static String QUERY_UPDATE_PSEQ =
        "UPDATE BOARD SET REPLY = REPLY + 1 WHERE SEQ = :PSEQ";

    private String act;

    /**
     * Article  ޾Ƽ db   
     *
     * @throws SQLException
     * @throws IOException
     */
    public void doWrite() throws SQLException, IOException {

        Connection conn = null;
        PreparedStatement pstmt = null;
        ResultSet rs = null;


        try {
            DbCon dc = new DbCon();

            //  Է
            conn = dc.getConnection();
            conn.setAutoCommit(false);

            if (!"BMODIFY.DO".equals(act)) {
                //  ƴϸ,  seq  ´.
                pstmt = conn.prepareStatement(QUERY_SEQ);
                rs = pstmt.executeQuery();
                if (rs.next()) {
                    this.setSeq(rs.getInt("SEQ"));
                }
                rs.close();
                pstmt.close();
            }

            if ("BWRITE.DO".equals(act)) {
                // Է ,  ref  Ѵ.
                pstmt = conn.prepareStatement(QUERY_REF);
                rs = pstmt.executeQuery();
                if(rs.next()) {
                    this.setRef(rs.getInt("REF"));
                }
                this.setRef(this.getRef()+1);
                rs.close();
                pstmt.close();

            } else if ("BREPLY.DO".equals(act)) {
                //   ش ref ׷ step  Ѵ.
                pstmt = conn.prepareStatement(QUERY_UPDATE_STEP);
                pstmt.setInt(1, this.getRef());
                pstmt.setInt(2, this.getStep());
                pstmt.executeUpdate();
                pstmt.close();

                // θۿ ۴޸ ǥø Ѵ.
                pstmt = conn.prepareStatement(QUERY_UPDATE_PSEQ);
                pstmt.setInt(1, this.getPseq());
                pstmt.executeUpdate();
                pstmt.close();

                //  step  lev ۺ ϳ  Ѵ.
                this.setStep(this.getStep()+1);
                this.setLev (this.getLev()+1);
            }

            if (!"BMODIFY.DO".equals(act)) {
                //  ƴ    ԷѴ.
                // ѱ    ѱó ƲǷ
                // CommonUtil.toKor() ޼ҵ带 ϰų  ġؼ
                // Ѵ.
                pstmt = conn.prepareStatement(QUERY_INSERT);

                pstmt.setInt   ( 1, this.getSeq() );
                pstmt.setInt   ( 2, this.getRef() );
                pstmt.setInt   ( 3, this.getStep());
                pstmt.setInt   ( 4, this.getLev() );
                pstmt.setString( 5, CommonUtil.toKor(this.getName    ()));
                pstmt.setString( 6, CommonUtil.toKor(this.getEmail   ()));
                pstmt.setString( 7, CommonUtil.toKor(this.getHomepage()));
                pstmt.setString( 8, CommonUtil.toKor(this.getSubject ()));
                pstmt.setString( 9, CommonUtil.toKor(this.getPassword()));
                pstmt.setInt   (10, this.getHtml() );
                pstmt.setInt   (11, this.getHit() );
                pstmt.setInt   (12, this.getPseq());
                pstmt.setInt   (13, this.getReply());

                int result = pstmt.executeUpdate();
                pstmt.close();

                if (result == 0) {
                    throw new SQLException(" ϵ ʾҽϴ.");
                }
            } else {
                //   
                pstmt = conn.prepareStatement(QUERY_MODIFY);

                pstmt.setString( 1, CommonUtil.toKor(this.getName    ()));
                pstmt.setString( 2, CommonUtil.toKor(this.getEmail   ()));
                pstmt.setString( 3, CommonUtil.toKor(this.getHomepage()));
                pstmt.setString( 4, CommonUtil.toKor(this.getSubject ()));
                pstmt.setString( 5, CommonUtil.toKor(this.getPassword()));
                pstmt.setInt   ( 6, this.getHtml() );
                pstmt.setInt   ( 7, this.getSeq() );

                int result = pstmt.executeUpdate();
                pstmt.close();

                if (result == 0) {
                    throw new SQLException("  ʾҽϴ.");
                }
            }


            // CLOB Է
            new ClobUtil().setClob(
                conn,
                this.getSeq(),
                CommonUtil.toKor(this.getContent()));

            conn.commit();
            // db  ݱ
        } catch (SQLException e) {
            conn.rollback();
            throw e;
        } finally {
            try {
                conn.setAutoCommit(true);
                conn.close();
            } catch (SQLException e) {
            }
        }
    }

    /**
     * Sets the act.
     * @param act The act to set
     */
    public void setAct(String act) {
        this.act = act;
    }

}
