package itexpert.chap12.example;

import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.xml.sax.InputSource;
import org.jdom.Document;
import org.jdom.Element;
import org.jdom.JDOMException;
import org.jdom.input.SAXBuilder;

public class ConfigurationServlet extends HttpServlet {

    private static final String path = "/WEB-INF/xml/configuration.xml";
    private Hashtable ht = new Hashtable();

    public void init() throws ServletException {
        InputStream inputStream    = getServletContext().getResourceAsStream(path);
        InputSource source = new InputSource(inputStream); 
        SAXBuilder builder = new SAXBuilder();
        Document doc = null;
        try {
            doc = builder.build(source);
        } catch(JDOMException e) {
            throw new ServletException("JDOMException : " + e.getMessage());
        }
        List list = doc.getRootElement().getChildren();
        Element configElement;
        BoardConfig boardConfig = null;
        for (Iterator i = list.iterator(); i.hasNext() ;) {
            boardConfig = new BoardConfig();
            configElement = (Element) i.next();
            boardConfig.setTitle(configElement.getChild("title").getText());
            boardConfig.setSkin(configElement.getChild("skin").getText());
            boardConfig.setLevel(Integer.parseInt(configElement.getChild("level").getText()));
            boardConfig.setDb(configElement.getChild("db").getText());
            // code Ӽ  Ű Ͽ ؽ̺ BoardConfig ü ִ´.
            ht.put(configElement.getAttribute("code").getValue(), boardConfig);
        }
    }

    public void doGet(HttpServletRequest request, HttpServletResponse response)
        throws ServletException, IOException {
        response.setContentType("text/html; charset=euc-kr");
        PrintWriter out = response.getWriter();
        String code = request.getParameter("code");
        if (code == null || code.equals("")) {
            out.println("Խ code  õǾ մϴ.");
            return;
        }
        if (ht.get(code) == null) {
            out.println("ġϴ Խ code ϴ.");
            return;
        }
        //  Ű ǿ  ̶ 
        int userLevel = 7;
        // Hashtable code Ű Ͽ BoardConfig ü ´.
        BoardConfig boardConfig =  (BoardConfig) ht.get(code);
        // Խ   Ѻ  Խ   .
        if (boardConfig.getLevel() > userLevel) {
            out.println("Խ   ϴ.");
            return;
        }
        // Ʈ  Խù SELECT( ڵ)
        String sql = "SELECT board_id, name, title, hit FROM " + boardConfig.getDb() + " WHERE ..";
        // ...    
        // request.setAttribute("..", ..); // Ͽ   request  
        request.setAttribute("boardConfig", boardConfig);
        //  /["skin"]/list.jsp  ̵Ѵ.
        String next = "/" + boardConfig.getSkin() + "/list.jsp";
        getServletContext().getRequestDispatcher(next).forward(request, response);
    }
}