package itexpert.chap12.sax;

import java.util.ArrayList;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import org.xml.sax.helpers.DefaultHandler;
import itexpert.chap12.Person;

public class AddressBookHandler extends DefaultHandler {

    private ArrayList list; // Person ü  ÷ ü
    private Person person;
    private StringBuffer buffer; // ±׳ ڿ  

    /**
     *  Ľ 
     * @see org.xml.sax.ContentHandler#startDocument()
     */
    public void startDocument() throws SAXException {
        list = new ArrayList();
        buffer = new StringBuffer();
    }

    /**
     *  Ľ 
     * @see org.xml.sax.ContentHandler#endDocument()
     */
    public void endDocument() throws SAXException {
        System.out.println("Document Ended");
    }

    /**
     *  ±װ   ȣ
     * @param uri ӽ̽ URIμ ⼭  
     * @param localName Ҹ
     * @param qName ӽ̽  Ҹ
     * @param attributes ҿ Ե Ӽ
     * @see org.xml.sax.ContentHandler#startElement(String, String, String, Attributes)
     */
    public void startElement(String uri, String localName, String qName, Attributes attributes)
        throws SAXException {
        buffer.setLength(0); // ο ±׸   ۸ 
        if (localName.equals("person")) { // person ±׸    Person ü 
            person = new Person();
            if(attributes.getValue("group") != null) {
                person.setGroup(Integer.parseInt(attributes.getValue("group")));
            }
        }
    }

    /**
     *  ±װ   ȣ
     * @param uri ӽ̽ URI
     * @param localName Ҹ
     * @param qName ӽ̽  Ҹ
     * @see org.xml.sax.ContentHandler#endElement(String, String, String)
     */
    public void endElement(String uri, String localName, String qName)
        throws SAXException {
        if (localName.equals("person")) { // person ±װ   ArrayList person ü 
            list.add(person);
        } else if (localName.equals("name")) {
            person.setName(buffer.toString().trim());
        } else if (localName.equals("email")) {
            person.setEmail(buffer.toString().trim());
        } else if (localName.equals("phone")) {
            person.setPhone(buffer.toString().trim());
        } else if (localName.equals("addr")) {
            person.setAddr(buffer.toString().trim());
        } else if (localName.equals("memo")) {
            person.setMemo(buffer.toString().trim());
        }
    }

    /**
     * ҳ ؽƮ ͸   ȣ
     * @param ch ڿ
     * @param start ڿ  ε
     * @param length ڿ  ε
     * @see org.xml.sax.ContentHandler#characters(char[], int, int)
     */
    public void characters(char[] ch, int start, int length)
        throws SAXException {
        buffer.append(ch, start, length);
    }

    /**
     * @see org.xml.sax.ErrorHandler#warning(SAXParseException)
     */
    public void warning(SAXParseException e) throws SAXException {
        System.err.println("[Warning] line " + e.getLineNumber() + ": " + e.getMessage());
    }

    /**
     * @see org.xml.sax.ErrorHandler#error(SAXParseException)
     */
    public void error(SAXParseException e) throws SAXException {
        System.err.println("[ERROR] line " + e.getLineNumber() + ": " + e.getMessage());
    }

    /**
     * @see org.xml.sax.ErrorHandler#fatalError(SAXParseException)
     */
    public void fatalError(SAXParseException e) throws SAXException {
        System.err.println("[FATAL] line " + e.getLineNumber() + ": " + e.getMessage());
    }

    /**
     * Ľ  Ʈ   ޼ҵ
     */
    public ArrayList getAddressBook() {
        return list;
    }
}