package itexpert.chap13.buy;

import java.util.Enumeration;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import org.apache.struts.action.ActionForm;
import org.apache.commons.beanutils.PropertyUtils;
import org.apache.log4j.Logger;
import itexpert.chap13.user.UserInfoBean;
import itexpert.chap13.util.DBResource;
import itexpert.chap13.util.ShopConstant;
import itexpert.chap13.exceptions.ShopDAOException;

public class OraOrderDAOImpl implements OrderDAO {
    
    Logger log = Logger.getLogger(OraOrderDAOImpl.class); 
    
    public void orderComplete(HttpServletRequest request) throws ShopDAOException {
        HttpSession session = request.getSession();
        // session  CartBean ü  ´.
        CartBean cart = (CartBean) session.getAttribute("cart");
        // ֹϷḦ ؼ   ʿϹǷ  session    ´.
        UserInfoBean userInfo = (UserInfoBean) session.getAttribute("userInfo");
        DBResource db = new DBResource();
        Connection con = null;
        PreparedStatement pstmt = null;
        try {
            // ORDERLIST ̺ ֹ  Էϴ 
            String sql = "INSERT INTO orderlist VALUES (?, ?, ?)";
            // BOOKS ̺  ҽŰ 
            String sql2 = "UPDATE books SET remaining=remaining-? WHERE isbn=?";
            con = db.getConnection(ShopConstant.SHOP_DATASOURCE);
            // Է     Ʈ  Ǿ Ѵ.
            con.setAutoCommit(false); 
            String id = userInfo.getId();
            BookBean book = null;
            for (Enumeration enum = cart.getItems().elements(); enum.hasMoreElements();) {
                book = (BookBean) enum.nextElement();
                pstmt = con.prepareStatement(sql);
                pstmt.setString(1, id);
                pstmt.setString(2, book.getIsbn());
                pstmt.setInt(3, book.getQuantity());
                pstmt.executeUpdate();

                pstmt = con.prepareStatement(sql2);
                pstmt.setInt(1, book.getQuantity());
                pstmt.setString(2, book.getIsbn());
                pstmt.executeUpdate();
            }
            con.commit();
            // Ÿ̽ ̺  Ŀ īƮ  Ѵ.
            cart.emptyCart();
        } catch (Exception e) {
            log.warn(e.toString());
            try {
                con.rollback();
            } catch(SQLException ex) {
                log.error(e.toString());
            }
            throw new ShopDAOException(e.getMessage());
        } finally {
            db.close(null, pstmt, con);
        }
    }
}