package itexpert.chap13.user;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionError;
import org.apache.log4j.Logger;
import itexpert.chap13.util.ShopConstant;
import itexpert.chap13.exceptions.ShopDAOException;

public class RegisterAction extends Action {

    Logger log = Logger.getLogger(RegisterAction.class);

    public ActionForward execute(ActionMapping mapping, 
                                ActionForm form, 
                                HttpServletRequest request, 
                                HttpServletResponse response)
    {

        try {
            UserDAO dao = UserDAOFactory.getDAO(ShopConstant.SHOP_DBTYPE);
            int checkResult = dao.registerUser(form, request, response);
            ActionErrors errors = new ActionErrors();
            if (checkResult > 0) {
                switch (checkResult) {
                    case ShopConstant.BLANK_NOTPERMMITED :
                        errors.add(ActionErrors.GLOBAL_ERROR,
                             new ActionError("error.blank.notpermitted"));
                        break;
                    case ShopConstant.ID_DUPLICATE : //  ̵ ̹ ϵǾ ִ 
                        errors.add(ActionErrors.GLOBAL_ERROR,
                             new ActionError("error.id.duplicate"));
                        break;
                    default :
                        errors.add(ActionErrors.GLOBAL_ERROR,
                             new ActionError("error.unknowned"));
                }
            }
            if (!errors.isEmpty()) {
                saveErrors(request, errors);
                return mapping.getInputForward(); 
            }
        } catch(Exception e) {
            log.error("register.execute", e);
            request.setAttribute("javax.servlet.jsp.jspException", e);
            return mapping.findForward("error");
        }
        return mapping.findForward("success");
    }
}
