package itexpert.chap13.util;

import java.io.IOException;
import java.io.File;
import java.io.PrintWriter;
import java.io.FileOutputStream;

import javax.servlet.ServletOutputStream;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.xml.sax.InputSource;
import org.xml.sax.XMLReader;

import org.apache.fop.apps.Driver;
import org.apache.fop.apps.Version;
import org.apache.fop.apps.Options;
import org.apache.fop.apps.XSLTInputHandler;
import org.apache.fop.messaging.MessageHandler;

import org.apache.avalon.framework.logger.ConsoleLogger;
import org.apache.avalon.framework.logger.Logger;

public class FopServlet extends HttpServlet {

    private static final String XSL_PATH = "/WEB-INF/xml/book/book.fo.xsl";
    private static final String CONFIG_PATH = "/WEB-INF/xml/userconfig.xml";
    Logger log = null;

    public void doGet(HttpServletRequest request,
                      HttpServletResponse response) throws ServletException, IOException {
        if (log == null) {
            log = new ConsoleLogger(ConsoleLogger.LEVEL_DEBUG);
            MessageHandler.setScreenLogger(log);
        }

        String isbn = request.getParameter("isbn");
        // ISBN  ٸ  ޽ ش.
        if (isbn == null || isbn.equals("")) {
            error(response, " ISBN  ϴ.");
            return;
        }
        String rootPath = getServletContext().getRealPath("/");
        String bookXml = rootPath + "/WEB-INF/xml/book/" + isbn + ".xml";
        File fileXml = new File(bookXml);
        //  XML  ٸ  ޽ ش.
        if (!fileXml.exists()) {
            error(response, "   غ ʾҽϴ.");
            return;
        }
        String bookXsl = rootPath + XSL_PATH;
        String bookPdf = "/preview/" + isbn + ".pdf";
        File filePdf = new File(rootPath + bookPdf);
        // PDF  ̹ ִٸ    ش.
        if (filePdf.exists()) {
            response.sendRedirect(request.getContextPath() + bookPdf);
            return;
        }
        try {
            XSLTInputHandler input = new XSLTInputHandler(fileXml, new File(bookXsl));
            FileOutputStream out = new FileOutputStream(filePdf);
            // userconfig.xml  Cyberbit Ʈ  ´.
            Options options = new Options(new File(rootPath + CONFIG_PATH));
            Driver driver = new Driver();
            // PDF ϸ鼭 α׸ .
            driver.setLogger(log);
            driver.setRenderer(Driver.RENDER_PDF);
            driver.setOutputStream(out);
            driver.render(input.getParser(), input.getInputSource());
            out.close();
            response.sendRedirect(request.getContextPath() + bookPdf);
        } catch (Exception e) {
            log.error("exception: " + e.getMessage());
            request.setAttribute("javax.servlet.jsp.jspException", e);
            getServletContext().getRequestDispatcher("/error.jsp").forward(request, response);
        }
    }

    //  ߻  ڹٽũƮ Alert â    ư Ѵ.
    private  void error(HttpServletResponse response, String message)
        throws ServletException, IOException
    {
        response.setContentType("text/html; charset=euc-kr");
        PrintWriter out = response.getWriter();
        out.println("<script language='javascript'>");
        out.println(" alert('" + message + "');");
        out.println(" history.back(); ");
        out.println("</script>");
    }
}