package itexpert.common;

import java.io.CharArrayReader;
import java.io.IOException;
import java.io.Reader;
import java.io.Writer;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import oracle.jdbc.driver.OracleResultSet;
import oracle.sql.CLOB;

/**
 * Ŭ Clob  ϴ ޼ҵ  Ŭ.
 *
 * @author kenu
 */
public class ClobUtil {

    final static String QUERY_INSERT_CONTENT =
        "SELECT CONTENT FROM BOARD WHERE SEQ = :SEQ FOR UPDATE";

    /**
     * DB clob ԷѴ. ĿؼǮ   ʴ 쿡
     *  DB ϴ Ŀؼ Ѵ.
     * @param conn
     * @param i
     * @param string
     */
    public void setClob(Connection conn, int seq, String content)
        throws SQLException, IOException {
        PreparedStatement pstmt = conn.prepareStatement(QUERY_INSERT_CONTENT);
        pstmt.setInt(1, seq);
        ResultSet rs = pstmt.executeQuery();

        if (rs.next()) {
            // ResultSet oracle.jdbc.driver.OracleResultSet ĳ Ŀ
            // CLOB ּҸ  oracle.sql.CLOB Է
            CLOB clob = ((OracleResultSet) rs).getCLOB(1);
            // CLOB ÷    Writer 
            Writer writer = clob.getCharacterOutputStream();
            // content String  Reader src ȯ  Է
            Reader src = new CharArrayReader(content.toCharArray());
            char[] buffer = new char[1024];
            int read = 0;
            // 1024 char  CLOB ÷ 
            while ((read = src.read(buffer, 0, 1024)) != -1) {
                writer.write(buffer, 0, read); // write clob.
            }
            src.close();
            writer.close();

        }
        rs.close();
        pstmt.close();

    }

    /**
     * clob ÷  о ȯѴ.
     * @param rs
     * @param column
     * @return String
     * @throws SQLException
     */
    public String getClob(ResultSet rs, String column)
        throws SQLException {

        StringBuffer sbuf = new StringBuffer();

        // content о
        sbuf.setLength(0);
        Reader reader = rs.getCharacterStream(column);
        char[] buffer = new char[1024];
        int read;
        try {
            while ((read = reader.read(buffer, 0, 1024)) != -1) {
                sbuf.append(buffer, 0, read);
            } // end while
            reader.close();
        } catch (IOException e) {
            System.out.println(e.toString());
        }

        return sbuf.toString();

    }

}
