package itexpert.chap13.user;

import itexpert.chap13.exceptions.ShopDAOException;
import itexpert.chap13.util.ShopConstant;
public class UserDAOFactory {

    /**
     * dbType  XXXUserImpl ü 
     * OraUserImpl Ŭ Ǿ  ٸ dbType ϱ  UserDAO Ͽ if  ߰ϸ ȴ.
     */
    public static UserDAO getDAO(String dbType) throws ShopDAOException {
        if (dbType.equals("oracle")) {
            return new OraUserDAOImpl();
        } else if(dbType.equals(ShopConstant.EJB_DAO)){ // Added for EJB based DAO
			return new EJBUserDAOImpl("java:comp/env/UserInfoEJB");
        } else {
        	throw new ShopDAOException("dbType: " + dbType + " NOT IMPLEMENTED");
        }
     }
}
