<?xml version="1.0" encoding="euc-kr"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
    xmlns:fo="http://www.w3.org/1999/XSL/Format"
    version="1.0">
 
    <xsl:template match="/">  
        <fo:root>
            <fo:layout-master-set>
                <fo:simple-page-master master-name="simple"
                      page-height="29.7cm" 
                      page-width="21cm"
                      margin-top="1cm" 
                      margin-bottom="2cm" 
                      margin-left="1.5cm" 
                      margin-right="1.5cm">
                    <fo:region-body margin-top="3cm"/>
                    <fo:region-before extent="3cm"/>
                    <fo:region-after extent="1.5cm"/>
                </fo:simple-page-master>
            </fo:layout-master-set>

            <fo:page-sequence master-reference="simple">

                <fo:flow flow-name="xsl-region-body">
                    <fo:block font-size="10pt" 
                        font-family="cyberbit" 
                        line-height="12pt"
                        space-after.optimum="15pt"
                        text-align="center"
                        padding-top="3pt">
                         ּҷ (ü <xsl:value-of select="count(/addressbook/person)"/>)
                    </fo:block>

                    <fo:table>
                        <fo:table-column column-width="20mm"/>
                        <fo:table-column column-width="20mm"/>
                        <fo:table-column column-width="50mm"/>
                        <fo:table-column column-width="20mm"/>
                        <fo:table-column column-width="50mm"/>
                        <fo:table-column column-width="20mm"/>
                        <fo:table-header>
                            <fo:table-row>
                                <fo:table-cell border-width="0.1mm"  border-style="solid">
                                    <fo:block font-size="9pt" font-family="cyberbit">׷</fo:block>
                                </fo:table-cell>
                                <fo:table-cell border-width="0.1mm"  border-style="solid">
                                    <fo:block font-size="9pt" font-family="cyberbit"≯</fo:block>
                                </fo:table-cell>
                                <fo:table-cell border-width="0.1mm"  border-style="solid">
                                    <fo:block font-size="9pt" font-family="cyberbit"≯</fo:block>
                                </fo:table-cell>
                                <fo:table-cell border-width="0.1mm"  border-style="solid">
                                    <fo:block font-size="9pt" font-family="cyberbit">ȭȣ</fo:block>
                                </fo:table-cell>
                                <fo:table-cell border-width="0.1mm"  border-style="solid">
                                    <fo:block font-size="9pt" font-family="cyberbit">ּ</fo:block>
                                </fo:table-cell>
                                <fo:table-cell border-width="0.1mm"  border-style="solid">
                                    <fo:block font-size="9pt" font-family="cyberbit">޸</fo:block>
                                </fo:table-cell>
                            </fo:table-row>
                        </fo:table-header>
                        <fo:table-body>
                            <xsl:for-each select="/addressbook/person">
                                <xsl:sort select="@group" data-type="number"/>
                                <xsl:sort select="name"/>
                                <xsl:apply-templates select="."/>
                            </xsl:for-each>
                            <xsl:if test="count(/addressbook/person)=0">
                                <fo:table-row>
                                    <fo:table-cell border-width="0.1mm" border-style="solid" number-columns-spanned="6">
                                        <fo:block text-align="center" font-size="9pt" font-family="cyberbit">Ͱ ϴ.</fo:block>
                                    </fo:table-cell>  
                                </fo:table-row>
                            </xsl:if>
                        </fo:table-body>
                    </fo:table>
                </fo:flow>

            </fo:page-sequence> 

        </fo:root>
    </xsl:template>

    <xsl:template match="person">
        <fo:table-row>
            <fo:table-cell border-width="0.1mm"  border-style="solid">
                <fo:block font-size="9pt" font-family="cyberbit">
                    <xsl:choose>
                        <xsl:when test="@group='1'"></xsl:when>
                        <xsl:when test="@group='2'">б</xsl:when>
                        <xsl:when test="@group='3'">ڹ</xsl:when>
                    </xsl:choose>
                </fo:block>
            </fo:table-cell>
            <fo:table-cell border-width="0.1mm"  border-style="solid">
                <fo:block font-size="9pt" font-family="cyberbit">
                    <xsl:value-of select="name"/>
                </fo:block>
            </fo:table-cell>
            <fo:table-cell border-width="0.1mm"  border-style="solid">
                <fo:block font-size="9pt" font-family="cyberbit">
                    <xsl:value-of select="email"/>
                </fo:block>
            </fo:table-cell>
            <fo:table-cell border-width="0.1mm"  border-style="solid">
                <fo:block font-size="9pt" font-family="cyberbit">
                    <xsl:value-of select="phone"/>
                </fo:block>
            </fo:table-cell>
            <fo:table-cell border-width="0.1mm"  border-style="solid">
                <fo:block font-size="9pt" font-family="cyberbit">
                    <xsl:value-of select="addr"/>
                </fo:block>
            </fo:table-cell>
            <fo:table-cell border-width="0.1mm"  border-style="solid">
                <fo:block font-size="9pt" font-family="cyberbit">
                    <xsl:value-of select="memo"/>
                </fo:block>
            </fo:table-cell>
        </fo:table-row>
    </xsl:template>

</xsl:stylesheet>
