<?xml version="1.0" encoding="euc-kr"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
    xmlns:fo="http://www.w3.org/1999/XSL/Format"
    version="1.0">

    <xsl:template match="book">  
        <fo:root>
            <fo:layout-master-set>
                <fo:simple-page-master master-name="simple"
                        page-height="29.7cm" 
                        page-width="21cm"
                        margin-top="2cm" 
                        margin-bottom="2cm" 
                        margin-left="1.5cm" 
                        margin-right="1.5cm">
                <fo:region-body margin-top="1cm" margin-bottom="1cm"/>
                <fo:region-before extent="1cm"/>
                <fo:region-after extent="1cm"/>
                </fo:simple-page-master>
            </fo:layout-master-set>

            <fo:page-sequence master-reference="simple">

                <fo:static-content flow-name="xsl-region-before">
                    <fo:block text-align="center" font-weight="bold" font-family="cyberbit">
                        <xsl:value-of select="chapter/title"/>
                    </fo:block>
                </fo:static-content>

                <fo:static-content flow-name="xsl-region-after">
                    <fo:block text-align="center">
                        p. <fo:page-number/>
                    </fo:block>
                </fo:static-content>

                <fo:flow flow-name="xsl-region-body">
                    <xsl:apply-templates select="chapter/abstract"/>
                    <xsl:apply-templates select="chapter/section"/>
                </fo:flow>

            </fo:page-sequence> 

        </fo:root>

    </xsl:template>

    <xsl:template match="abstract">
     <fo:block font-size="9pt" 
               font-family="cyberbit" 
               line-height="12pt"
               space-after.optimum="15pt"
               padding-top="3pt">
            <xsl:value-of select="."/>
        </fo:block>
    </xsl:template>

    <xsl:template match="section">
        <fo:block font-size="10pt" 
                  font-weight="bold"
                  font-family="cyberbit"
                  space-after.optimum="12pt">
            <xsl:value-of select="title"/>
        </fo:block>
        <xsl:apply-templates select="content"/>
    </xsl:template>

    <xsl:template match="content">
        <xsl:for-each select="paragraph">
            <fo:block font-size="10pt"
                      font-family="cyberbit"
                      space-after.optimum="9pt"
                      text-align="justify">
                <xsl:value-of select="."/>
            </fo:block>
        </xsl:for-each>
    </xsl:template>

</xsl:stylesheet>